const l0 = require("./l0")

const TYPE_MD = {
    raw:10,q:11,
    10:'raw',11:'q'
}


class RawTok {
    constructor(chunk,l0_raw_tok) {
        this.type = 10;
        this.raw = chunk.slice(l0_raw_tok.si,l0_raw_tok.ei)
    }
    stringify() {return(this.raw)}
}


class Qtok {
    constructor(chunk,l0_qtok) {
        this.type = 11;
        this.raw = chunk.slice(l0_qtok.si,l0_qtok.ei)
    }
    stringify() {return(this.raw)}
}


function map_l0_toks(chunk,toks) {
    return(
        toks.map(
            l0tok => {
                if(l0.is_raw_tok(l0tok)) {
                    return(new RawTok(chunk,l0tok))
                } else {
                    return(new Qtok(chunk,l0tok))
                }
            }
        )
    )
}



module.exports = {
    RawTok,
    Qtok,
    map_l0_toks,
    TYPE_MD,
    is_raw_tok:(o)=>(o instanceof RawTok),
    is_qtok:(o)=>(o instanceof Qtok),
    is_l1_tok:(o)=> (o.type>=10 && o.type<100),
}
